'
'
'

Rem
bbdoc: 
about: 
EndRem
Type VLayer

	Field _tag:Int
	Field _bound:Int

	Field _posx:Float
	Field _posy:Float
	Field _handlex:Float
	Field _handley:Float
	Field _rothandlex:Float
	Field _rothandley:Float
	Field _scalex:Float
	Field _scaley:Float
	Field _rotation:Float
	Field _width:Float
	Field _height:Float
	Field _colorr:Float
	Field _colorg:Float
	Field _colorb:Float
	Field _colora:Float
	Field _blend:Int
	
	Field _clip:Int
	Field _stencil:Int
	
	Field _oldlayer:VLayer
	
	Rem
	bbdoc: 
	about: 
	EndRem
	Function Create:VLayer()
		Local ret_:VLayer = New VLayer
			ret_.init()
		Return ret_
	EndFunction
	
	Rem
	bbdoc: 
	about: 
	EndRem
	Method init()
		_tag = 0
		_posx = 0.0
		_posy = 0.0
		_handlex = 0.0
		_handley = 0.0
		_scalex = 1.0
		_scaley = 1.0
		_rotation = 0.0
		_width = 1.0
		_height = 1.0
		_colorr = 1.0
		_colorg = 1.0
		_colorb = 1.0
		_colora = 1.0
		_clip = 0
		_stencil = 0
		_oldlayer = Null
	EndMethod

	'----------
	'push / pop
	'----------
	
	Method push()
		_oldlayer = Visuals.getInstance().currentLayer()
		Visuals.getInstance().setCurrentLayer(Self)
		Self.bind()
	EndMethod
	
	Method pop()
		Self.unbind()
		Visuals.getInstance().setCurrentLayer(_oldlayer)
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Method setX( posx_:Float )
		_posx = posx_
	EndMethod
	
	Method getX:Float()
		Return _posx
	EndMethod
	
	Method setY( posy_:Float )
		_posy = posy_
	EndMethod
	
	Method getY:Float()
		Return _posy
	EndMethod
	
	Method setHandleX( handlex_:Float )
		_handlex = handlex_
	EndMethod
	
	Method getHandleX:Float()
		Return _handlex
	EndMethod
	
	Method setHandleY( handley_:Float )
		_handley = handley_
	EndMethod
	
	Method setRotationHandleX( handlex_:Float )
		_rothandlex = handlex_
	EndMethod
	
	Method getRotationHandleX:Float()
		Return _rothandlex
	EndMethod
	
	Method setRotationHandleY( handley_:Float )
		_rothandley = handley_
	EndMethod
	
	Method getRotationHandleY:Float()
		Return _rothandley
	EndMethod
	
	Method getHandleY:Float()
		Return _handley
	EndMethod
	
	Method setScaleX( scalex_:Float )
		_scalex = scalex_
	EndMethod
	
	Method getScaleX:Float()
		Return _scalex
	EndMethod
	
	Method setScaleY( scaley_:Float )
		_scaley = scaley_
	EndMethod
	
	Method getScaleY:Float()
		Return _scaley
	EndMethod
	
	Method setRotate( rotation_:Float )
		_rotation = rotation_
	EndMethod
	
	Method getRotate:Float()
		Return _rotation
	EndMethod
	
	Method setWidth( width_:Float )
		_width = width_
	EndMethod
	
	Method getWidth:Float()
		Return _width
	EndMethod
	
	Method setHeight( height_:Float )
		_height = height_
	EndMethod
	
	Method getHeight:Float()
		Return _height
	EndMethod
	
	'-------
	'binding
	'-------
	
	Method bind()
		_applyStencil()
		glPushMatrix()
		glMatrixMode(GL_MODELVIEW)
		glTranslatef( _posx+_rothandlex, _posy+_rothandley, 0.0 )
		glRotatef(_rotation, 0.0, 0.0, 1.0)
		glTranslatef( -_handlex-_rothandlex, -_handley-_rothandley, 0.0 )
		glScalef(_scalex, _scaley, 1.0)
		glColor4f(_colorr, _colorg, _colorb, _colora)
		_bound = 1
	EndMethod
	
	Method unbind()
		glPopMatrix()
		_bound = 0
	EndMethod
	
	Method bindStencil()
		'glEnable(GL_STENCIL_TEST)
		'glStencilFunc(GL_EQUAL, 8, 0)
	EndMethod
	
	Method unbindStencil()
		'glEnable(GL_STENCIL_TEST)
		'glStencilFunc(GL_EQUAL, 8, 0)
	EndMethod
	
	'-------
	'private
	'-------
	
	Method _applyStencil()
		If _clip
			'glEnable(GL_SCISSOR_TEST) 
			'glScissor( _posx, GraphicsHeight()-_posy-_height, _width, _height )
		EndIf
		If _stencil
			'glEnable(GL_STENCIL_TEST)
			'glStencilFunc(GL_EQUAL, 8, 0)
		EndIf
	EndMethod
	
	'-----
	'debug
	'-----
	
	Method stroke()
		?debug
		'Self.setRGBf(1.0, 0.0, 0.0)
		If Not _bound Self.bind()
		glColor4f(1.0, 0.0, 0.0, 1.0) 'BOUNDS (RED)
		glBegin(GL_LINE_LOOP)
			glVertex2f(0.5, 0.5)
			glVertex2f(0.5, _height-0.5)
			glVertex2f(_width-0.5, _height-0.5)
			glVertex2f(_width-0.5, 0.5)
		glEnd()
		glBegin(GL_POINTS)
			glColor4f(0.0, 1.0, 0.0, 1.0) 'ROTATION HANDLE (GREEN)
			glVertex2f(_rothandlex, _rothandley)
			glColor4f(0.0, 1.0, 0.0, 1.0) 'HANDLE (BLUE)
			glVertex2f(_handlex, _handley)
		glEnd()
		'Self.unbind()
		?
	EndMethod

EndType
